diff --git a/testsuite/sha384-test.c b/testsuite/sha384-test.c
index 086e115..702e73b 100644
--- a/testsuite/sha384-test.c
+++ b/testsuite/sha384-test.c
@@ -4,54 +4,54 @@
 int
 test_main(void)
 {
-  test_hash(&nettle_sha384, 3, "abc",
-	    H("cb00753f45a35e8b b5a03d699ac65007"
+  test_hash(&nettle_sha384, "abc",
+	    "cb00753f45a35e8b b5a03d699ac65007"
 	      "272c32ab0eded163 1a8b605a43ff5bed"
-	      "8086072ba1e7cc23 58baeca134c825a7"));
+	      "8086072ba1e7cc23 58baeca134c825a7");
   
-  test_hash(&nettle_sha384, 112,
+  test_hash(&nettle_sha384,
 	    "abcdefghbcdefghicdefghijdefg"
 	    "hijkefghijklfghijklmghijklmn"
 	    "hijklmnoijklmnopjklmnopqklmn"
 	    "opqrlmnopqrsmnopqrstnopqrstu",
-	    H("09330c33f71147e8 3d192fc782cd1b47"
+	    "09330c33f71147e8 3d192fc782cd1b47"
 	      "53111b173b3b05d2 2fa08086e3b0f712"
-	      "fcc7c71a557e2db9 66c3e9fa91746039"));
+	      "fcc7c71a557e2db9 66c3e9fa91746039");
 
   /* Additional test vectors, from Daniel Kahn Gillmor */
-  test_hash(&nettle_sha384, LDATA(""),
-	    H("38b060a751ac9638 4cd9327eb1b1e36a"
+  test_hash(&nettle_sha384, "",
+	    "38b060a751ac9638 4cd9327eb1b1e36a"
 	      "21fdb71114be0743 4c0cc7bf63f6e1da"
-	      "274edebfe76f65fb d51ad2f14898b95b"));
-  test_hash(&nettle_sha384, LDATA("a"),
-	    H("54a59b9f22b0b808 80d8427e548b7c23"
+	      "274edebfe76f65fb d51ad2f14898b95b");
+  test_hash(&nettle_sha384, "a",
+	    "54a59b9f22b0b808 80d8427e548b7c23"
 	      "abd873486e1f035d ce9cd697e8517503"
-	      "3caa88e6d57bc35e fae0b5afd3145f31"));
-  test_hash(&nettle_sha384, LDATA("38"),
-	    H("c071d202ad950b6a 04a5f15c24596a99"
+	      "3caa88e6d57bc35e fae0b5afd3145f31");
+  test_hash(&nettle_sha384, "38",
+	    "c071d202ad950b6a 04a5f15c24596a99"
 	      "3af8b212467958d5 70a3ffd478006063"
-	      "8e3a3d06637691d3 012bd31122071b2c"));
-  test_hash(&nettle_sha384, LDATA("message digest"),
-	    H("473ed35167ec1f5d 8e550368a3db39be"
+	      "8e3a3d06637691d3 012bd31122071b2c");
+  test_hash(&nettle_sha384, "message digest",
+	    "473ed35167ec1f5d 8e550368a3db39be"
 	      "54639f828868e945 4c239fc8b52e3c61"
-	      "dbd0d8b4de1390c2 56dcbb5d5fd99cd5"));
-  test_hash(&nettle_sha384, LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("feb67349df3db6f5 924815d6c3dc133f"
+	      "dbd0d8b4de1390c2 56dcbb5d5fd99cd5");
+  test_hash(&nettle_sha384, "abcdefghijklmnopqrstuvwxyz",
+	    "feb67349df3db6f5 924815d6c3dc133f"
 	      "091809213731fe5c 7b5f4999e463479f"
-	      "f2877f5f2936fa63 bb43784b12f3ebb4"));
+	      "f2877f5f2936fa63 bb43784b12f3ebb4");
   test_hash(&nettle_sha384,
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdef"
-		  "ghijklmnopqrstuvwxyz0123456789"),
-	    H("1761336e3f7cbfe5 1deb137f026f89e0"
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdef"
+		  "ghijklmnopqrstuvwxyz0123456789",
+	    "1761336e3f7cbfe5 1deb137f026f89e0"
 	      "1a448e3b1fafa640 39c1464ee8732f11"
-	      "a5341a6f41e0c202 294736ed64db1a84"));
+	      "a5341a6f41e0c202 294736ed64db1a84");
   test_hash(&nettle_sha384,
-	    LDATA("12345678901234567890123456789012"
+	    "12345678901234567890123456789012"
 		  "34567890123456789012345678901234"
-		  "5678901234567890"),
-	    H("b12932b0627d1c06 0942f54477641556"
+		  "5678901234567890",
+	    "b12932b0627d1c06 0942f54477641556"
 	      "55bd4da0c9afa6dd 9b9ef53129af1b8f"
-	      "b0195996d2de9ca0 df9d821ffee67026"));
+	      "b0195996d2de9ca0 df9d821ffee67026");
 
   SUCCESS();
 }
diff --git a/testsuite/sha512-test.c b/testsuite/sha512-test.c
index 97bde53..d97b384 100644
--- a/testsuite/sha512-test.c
+++ b/testsuite/sha512-test.c
@@ -4,63 +4,63 @@
 int
 test_main(void)
 {
-  test_hash(&nettle_sha512, 3, "abc",
-	    H("ddaf35a193617aba cc417349ae204131"
+  test_hash(&nettle_sha512, "abc",
+	    "ddaf35a193617aba cc417349ae204131"
 	      "12e6fa4e89a97ea2 0a9eeee64b55d39a"
 	      "2192992a274fc1a8 36ba3c23a3feebbd"
-	      "454d4423643ce80e 2a9ac94fa54ca49f"));
+	      "454d4423643ce80e 2a9ac94fa54ca49f");
   
-  test_hash(&nettle_sha512, 112,
+  test_hash(&nettle_sha512,
 	    "abcdefghbcdefghicdefghijdefg"
 	    "hijkefghijklfghijklmghijklmn"
 	    "hijklmnoijklmnopjklmnopqklmn"
 	    "opqrlmnopqrsmnopqrstnopqrstu",
-	    H("8e959b75dae313da 8cf4f72814fc143f"
+	    "8e959b75dae313da 8cf4f72814fc143f"
 	      "8f7779c6eb9f7fa1 7299aeadb6889018"
 	      "501d289e4900f7e4 331b99dec4b5433a"
-	      "c7d329eeb6dd2654 5e96e55b874be909"));
+	      "c7d329eeb6dd2654 5e96e55b874be909");
 
   /* Additional test vectors, from Daniel Kahn Gillmor */
-  test_hash(&nettle_sha512, LDATA(""),
-	    H("cf83e1357eefb8bd f1542850d66d8007"
+  test_hash(&nettle_sha512, "",
+	    "cf83e1357eefb8bd f1542850d66d8007"
 	      "d620e4050b5715dc 83f4a921d36ce9ce"
 	      "47d0d13c5d85f2b0 ff8318d2877eec2f"
-	      "63b931bd47417a81 a538327af927da3e"));
-  test_hash(&nettle_sha512, LDATA("a"),
-	    H("1f40fc92da241694 750979ee6cf582f2"
+	      "63b931bd47417a81 a538327af927da3e");
+  test_hash(&nettle_sha512, "a",
+	    "1f40fc92da241694 750979ee6cf582f2"
 	      "d5d7d28e18335de0 5abc54d0560e0f53"
 	      "02860c652bf08d56 0252aa5e74210546"
-	      "f369fbbbce8c12cf c7957b2652fe9a75"));
-  test_hash(&nettle_sha512, LDATA("38"),
-	    H("caae34a5e8103126 8bcdaf6f1d8c04d3"
+	      "f369fbbbce8c12cf c7957b2652fe9a75");
+  test_hash(&nettle_sha512, "38",
+	    "caae34a5e8103126 8bcdaf6f1d8c04d3"
 	      "7b7f2c349afb705b 575966f63e2ebf0f"
 	      "d910c3b05160ba08 7ab7af35d40b7c71"
-	      "9c53cd8b947c9611 1f64105fd45cc1b2"));
-  test_hash(&nettle_sha512, LDATA("message digest"),
-	    H("107dbf389d9e9f71 a3a95f6c055b9251"
+	      "9c53cd8b947c9611 1f64105fd45cc1b2");
+  test_hash(&nettle_sha512, "message digest",
+	    "107dbf389d9e9f71 a3a95f6c055b9251"
 	      "bc5268c2be16d6c1 3492ea45b0199f33"
 	      "09e16455ab1e9611 8e8a905d5597b720"
-	      "38ddb372a8982604 6de66687bb420e7c"));
-  test_hash(&nettle_sha512, LDATA("abcdefghijklmnopqrstuvwxyz"),
-	    H("4dbff86cc2ca1bae 1e16468a05cb9881"
+	      "38ddb372a8982604 6de66687bb420e7c");
+  test_hash(&nettle_sha512, "abcdefghijklmnopqrstuvwxyz",
+	    "4dbff86cc2ca1bae 1e16468a05cb9881"
 	      "c97f1753bce36190 34898faa1aabe429"
 	      "955a1bf8ec483d74 21fe3c1646613a59"
-	      "ed5441fb0f321389 f77f48a879c7b1f1"));
+	      "ed5441fb0f321389 f77f48a879c7b1f1");
   test_hash(&nettle_sha512,
-	    LDATA("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdef"
-		  "ghijklmnopqrstuvwxyz0123456789"),
-	    H("1e07be23c26a86ea 37ea810c8ec78093"
+	    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdef"
+		  "ghijklmnopqrstuvwxyz0123456789",
+	    "1e07be23c26a86ea 37ea810c8ec78093"
 	      "52515a970e9253c2 6f536cfc7a9996c4"
 	      "5c8370583e0a78fa 4a90041d71a4ceab"
-	      "7423f19c71b9d5a3 e01249f0bebd5894"));
+	      "7423f19c71b9d5a3 e01249f0bebd5894");
   test_hash(&nettle_sha512,
-	    LDATA("12345678901234567890123456789012"
+	    "12345678901234567890123456789012"
 		  "34567890123456789012345678901234"
-		  "5678901234567890"),
-	    H("72ec1ef1124a45b0 47e8b7c75a932195"
+		  "5678901234567890",
+	    "72ec1ef1124a45b0 47e8b7c75a932195"
 	      "135bb61de24ec0d1 914042246e0aec3a"
 	      "2354e093d76f3048 b456764346900cb1"
-	      "30d2a4fd5dd16abb 5e30bcb850dee843"));
+	      "30d2a4fd5dd16abb 5e30bcb850dee843");
 
   SUCCESS();
 }
diff --git a/testsuite/testutils.c b/testsuite/testutils.c
index 1b0fd88..47c7693 100644
--- a/testsuite/testutils.c
+++ b/testsuite/testutils.c
@@ -46,6 +46,33 @@ xalloc(size_t size)
   return p;
 }
 
+int
+memeq_hex(unsigned length, const uint8_t *s1, const uint8_t *s2_hex)
+{
+  unsigned s2_length = decode_hex_length(s2_hex);
+  const uint8_t *s2 = decode_hex_dup(s2_hex);
+  int result = (length == s2_length) && !memcmp(s1, s2, length);
+
+  free((void *)s2);
+  return result;
+}
+
+const uint8_t *
+encode_hex_dup(const uint8_t *data, unsigned length)
+{
+  unsigned i;
+  uint8_t *hex = xalloc(length * 2 + 1);
+
+  *hex = 0;
+
+  for (i = 0; i < length; i++)
+    {
+      sprintf(&hex[i*2], "%02x", data[i]);
+    }
+
+  return hex;
+}
+
 unsigned
 decode_hex_length(const char *h)
 {
@@ -163,12 +190,16 @@ main(int argc, char **argv)
 
 void
 test_cipher(const struct nettle_cipher *cipher,
-	    unsigned key_length,
-	    const uint8_t *key,
-	    unsigned length,
-	    const uint8_t *cleartext,
-	    const uint8_t *ciphertext)
+	    const uint8_t *key_hex,
+	    const uint8_t *cleartext_hex,
+	    const uint8_t *ciphertext_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+
   void *ctx = xalloc(cipher->context_size);
   uint8_t *data = xalloc(length);
 
@@ -201,19 +232,27 @@ test_cipher(const struct nettle_cipher *cipher,
       FAIL();
     }
 
-  free(ctx);
   free(data);
+  free(ctx);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)key);
 }
 
 void
 test_cipher_cbc(const struct nettle_cipher *cipher,
-		unsigned key_length,
-		const uint8_t *key,
-		unsigned length,
-		const uint8_t *cleartext,
-		const uint8_t *ciphertext,
-		const uint8_t *iiv)
+		const uint8_t *key_hex,
+		const uint8_t *cleartext_hex,
+		const uint8_t *ciphertext_hex,
+		const uint8_t *iiv_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+  const uint8_t *iiv = decode_hex_dup(iiv_hex);
+
   void *ctx = xalloc(cipher->context_size);
   uint8_t *data = xalloc(length);
   uint8_t *iv = xalloc(cipher->block_size);
@@ -254,20 +293,30 @@ test_cipher_cbc(const struct nettle_cipher *cipher,
       fprintf(stderr, "\n");
       FAIL();
     }
-  free(ctx);
-  free(data);
+
   free(iv);
+  free(data);
+  free(ctx);
+  free((void *)iiv);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)key);
 }
 
 void
 test_cipher_ctr(const struct nettle_cipher *cipher,
-		unsigned key_length,
-		const uint8_t *key,
-		unsigned length,
-		const uint8_t *cleartext,
-		const uint8_t *ciphertext,
-		const uint8_t *ictr)
+		const uint8_t *key_hex,
+		const uint8_t *cleartext_hex,
+		const uint8_t *ciphertext_hex,
+		const uint8_t *ictr_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+  const uint8_t *ictr = decode_hex_dup(ictr_hex);
+
   void *ctx = xalloc(cipher->context_size);
   uint8_t *data = xalloc(length);
   uint8_t *ctr = xalloc(cipher->block_size);
@@ -309,21 +358,29 @@ test_cipher_ctr(const struct nettle_cipher *cipher,
       FAIL();
     }
 
-  free(ctx);
-  free(data);
   free(ctr);
+  free(data);
+  free(ctx);
+  free((void *)ictr);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)key);
 }
 
 void
 test_cipher_stream(const struct nettle_cipher *cipher,
-		   unsigned key_length,
-		   const uint8_t *key,
-		   unsigned length,
-		   const uint8_t *cleartext,
-		   const uint8_t *ciphertext)
+		   const uint8_t *key_hex,
+		   const uint8_t *cleartext_hex,
+		   const uint8_t *ciphertext_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+
   unsigned block;
-  
+
   void *ctx = xalloc(cipher->context_size);
   uint8_t *data = xalloc(length + 1);
   
@@ -376,23 +433,33 @@ test_cipher_stream(const struct nettle_cipher *cipher,
       FAIL();	    
     }
 
-  free(ctx);
   free(data);
+  free(ctx);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)key);
 }
 
 void
 test_aead(const struct nettle_aead *aead,
-	  unsigned key_length,
-	  const uint8_t *key,
-	  unsigned auth_length,
-	  const uint8_t *authtext,
-	  unsigned length,
-	  const uint8_t *cleartext,
-	  const uint8_t *ciphertext,
-	  unsigned iv_length,
-	  const uint8_t *iv,
-	  const uint8_t *digest)
+	  const uint8_t *key_hex,
+	  const uint8_t *authtext_hex,
+	  const uint8_t *cleartext_hex,
+	  const uint8_t *ciphertext_hex,
+	  const uint8_t *iv_hex,
+	  const uint8_t *digest_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  unsigned auth_length = decode_hex_length(authtext_hex);
+  const uint8_t *authtext = decode_hex_dup(authtext_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+  unsigned iv_length = decode_hex_length(iv_hex);
+  const uint8_t *iv = decode_hex_dup(iv_hex);
+  const uint8_t *digest = decode_hex_dup(digest_hex);
+
   void *ctx = xalloc(aead->context_size);
   uint8_t *data = xalloc(length);
   uint8_t *buffer = xalloc(aead->block_size);
@@ -438,14 +505,22 @@ test_aead(const struct nettle_aead *aead,
   free(ctx);
   free(data);
   free(buffer);
+  free((void *)digest);
+  free((void *)iv);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)authtext);
+  free((void *)key);
 }
 
 void
-test_hash(const struct nettle_hash *hash,
-	  unsigned length,
+test_hash_mem(const struct nettle_hash *hash,
+          unsigned length,
 	  const uint8_t *data,
-	  const uint8_t *digest)
+	  const uint8_t *digest_hex)
 {
+  const uint8_t *digest = decode_hex_dup(digest_hex);
+
   void *ctx = xalloc(hash->context_size);
   uint8_t *buffer = xalloc(hash->digest_size);
 
@@ -468,8 +543,32 @@ test_hash(const struct nettle_hash *hash,
   if (buffer[hash->digest_size - 1])
     FAIL();
 
-  free(ctx);
   free(buffer);
+  free(ctx);
+  free((void *)digest);
+}
+
+void
+test_hash(const struct nettle_hash *hash,
+	  const uint8_t *data,
+	  const uint8_t *digest_hex)
+{
+  unsigned length = strlen(data);
+
+  test_hash_mem(hash, length, data, digest_hex);
+}
+
+void
+test_hash_hex(const struct nettle_hash *hash,
+	  const uint8_t *data_hex,
+	  const uint8_t *digest_hex)
+{
+  unsigned length = decode_hex_length(data_hex);
+  const uint8_t *data = decode_hex_dup(data_hex);
+
+  test_hash_mem(hash, length, data, digest_hex);
+
+  free((void *)data);
 }
 
 void
@@ -1069,6 +1168,8 @@ test_dsa_key(struct dsa_public_key *pub,
   
   mpz_powm(t, pub->g, key->x, pub->p);
   ASSERT(0 == mpz_cmp(t, pub->y));
+
+  mpz_clear(t);
 }
 
 #endif /* WITH_HOGWEED */
diff --git a/testsuite/testutils.h b/testsuite/testutils.h
index d7ced9a..8b35160 100644
--- a/testsuite/testutils.h
+++ b/testsuite/testutils.h
@@ -32,6 +32,12 @@ extern "C" {
 void *
 xalloc(size_t size);
 
+int
+memeq_hex(unsigned length, const uint8_t *s1, const uint8_t *s2_hex);
+
+const uint8_t *
+encode_hex_dup(const uint8_t *data, unsigned length);
+
 /* Decodes a NUL-terminated hex string. */
 
 unsigned
@@ -84,56 +90,54 @@ struct nettle_mac
  
 void
 test_cipher(const struct nettle_cipher *cipher,
-	    unsigned key_length,
-	    const uint8_t *key,
-	    unsigned length,
-	    const uint8_t *cleartext,
-	    const uint8_t *ciphertext);
+	    const uint8_t *key_hex,
+	    const uint8_t *cleartext_hex,
+	    const uint8_t *ciphertext_hex);
 
 void
 test_cipher_cbc(const struct nettle_cipher *cipher,
-		unsigned key_length,
 		const uint8_t *key,
-		unsigned length,
 		const uint8_t *cleartext,
 		const uint8_t *ciphertext,
 		const uint8_t *iv);
 
 void
 test_cipher_ctr(const struct nettle_cipher *cipher,
-		unsigned key_length,
-		const uint8_t *key,
-		unsigned length,
-		const uint8_t *cleartext,
-		const uint8_t *ciphertext,
-		const uint8_t *iv);
+		const uint8_t *key_hex,
+		const uint8_t *cleartext_hex,
+		const uint8_t *ciphertext_hex,
+		const uint8_t *iv_hex);
 
 void
 test_cipher_stream(const struct nettle_cipher *cipher,
-		   unsigned key_length,
-		   const uint8_t *key,
-		   unsigned length,
-		   const uint8_t *cleartext,
-		   const uint8_t *ciphertext);
+		   const uint8_t *key_hex,
+		   const uint8_t *cleartext_hex,
+		   const uint8_t *ciphertext_hex);
 
 void
 test_aead(const struct nettle_aead *aead,
-	  unsigned key_length,
-	  const uint8_t *key,
-	  unsigned auth_length,
-	  const uint8_t *authtext,
+	  const uint8_t *key_hex,
+	  const uint8_t *authtext_hex,
+	  const uint8_t *cleartext_hex,
+	  const uint8_t *ciphertext_hex,
+	  const uint8_t *iv_hex,
+	  const uint8_t *digest_hex);
+
+void
+test_hash_mem(const struct nettle_hash *hash,
 	  unsigned length,
-	  const uint8_t *cleartext,
-	  const uint8_t *ciphertext,
-	  unsigned iv_length,
-	  const uint8_t *iv,
-	  const uint8_t *digest);
+	  const uint8_t *data,
+	  const uint8_t *digest_hex);
 
 void
 test_hash(const struct nettle_hash *hash,
-	  unsigned length,
 	  const uint8_t *data,
-	  const uint8_t *digest);
+	  const uint8_t *digest_hex);
+
+void
+test_hash_hex(const struct nettle_hash *hash,
+	  const uint8_t *data_hex,
+	  const uint8_t *digest_hex);
 
 void
 test_hash_large(const struct nettle_hash *hash,
@@ -203,19 +207,13 @@ test_dsa_key(struct dsa_public_key *pub,
 }
 #endif
 
-#define H2(d, s) decode_hex((d), (s))
 #define H(x) decode_hex_dup(x)
-#define HL(x) decode_hex_length(x), decode_hex_dup(x)
 
 /* LDATA needs to handle NUL characters. */
 #define LLENGTH(x) (sizeof(x) - 1)
 #define LDATA(x) (sizeof(x) - 1), x
-#define LDUP(x) strlen(x), strdup(x)
 
 #define MEMEQ(length, a, b) (!memcmp((a), (b), (length)))
-#define MEMEQH(length, a, b) \
-((length) == decode_hex_length((b)) \
- && !memcmp((a), decode_hex_dup((b)), (length)))
 
 #define FAIL() abort()
 #define SKIP() exit(77)
diff --git a/testsuite/twofish-test.c b/testsuite/twofish-test.c
index 65558d3..5a50a99 100644
--- a/testsuite/twofish-test.c
+++ b/testsuite/twofish-test.c
@@ -6,23 +6,23 @@ test_main(void)
 {
   /* 128 bit key */
   test_cipher(&nettle_twofish128,
-	      HL("0000000000000000 0000000000000000"),
-	      HL("0000000000000000 0000000000000000"),
-	      H("9F589F5CF6122C32 B6BFEC2F2AE8C35A"));
+	      "0000000000000000 0000000000000000",
+	      "0000000000000000 0000000000000000",
+	      "9F589F5CF6122C32 B6BFEC2F2AE8C35A");
 
   /* 192 bit key */
   test_cipher(&nettle_twofish192,
-	      HL("0123456789ABCDEF FEDCBA9876543210"
-		 "0011223344556677"),
-	      HL("0000000000000000 0000000000000000"),
-	      H("CFD1D2E5A9BE9CDF 501F13B892BD2248"));
+	      "0123456789ABCDEF FEDCBA9876543210"
+		 "0011223344556677",
+	      "0000000000000000 0000000000000000",
+	      "CFD1D2E5A9BE9CDF 501F13B892BD2248");
 
   /* 256 bit key */
   test_cipher(&nettle_twofish256,
-	      HL("0123456789ABCDEF FEDCBA9876543210"
-		 "0011223344556677 8899AABBCCDDEEFF"),
-	      HL("0000000000000000 0000000000000000"),
-	      H("37527BE0052334B8 9F0CFCCAE87CFA20"));
+	      "0123456789ABCDEF FEDCBA9876543210"
+		 "0011223344556677 8899AABBCCDDEEFF",
+	      "0000000000000000 0000000000000000",
+	      "37527BE0052334B8 9F0CFCCAE87CFA20");
 
   SUCCESS();
 }
diff --git a/testsuite/yarrow-test.c b/testsuite/yarrow-test.c
index 5f01e76..007a650 100644
--- a/testsuite/yarrow-test.c
+++ b/testsuite/yarrow-test.c
@@ -39,6 +39,8 @@ get_event(FILE *f, struct sha256_ctx *hash,
 static FILE *
 open_file(const char *name)
 {
+  FILE *fp;
+
   /* Tries opening the file in $srcdir, if set, otherwise the current
    * working directory */
 
@@ -48,11 +50,17 @@ open_file(const char *name)
       /* Leaks this name, but that doesn't matter. */
       char *buf = xalloc(strlen(name) + strlen(srcdir) + 10);
       sprintf(buf, "%s/%s", srcdir, name);
-      name = buf;
+      /* Opens the file in text mode. */
+      fp = fopen(buf, "r");
+      free(buf);
+    }
+  else
+    {
+      /* Opens the file in text mode. */
+      fp = fopen(name, "r");
     }
 
-  /* Opens the file in text mode. */
-  return fopen(name, "r");
+  return fp;
 }
 
 int
@@ -216,6 +224,11 @@ test_main(void)
       fprintf(stderr, "Failed.\n");
       return EXIT_FAILURE;
     }
-  
+
+  fclose(input);
+  free((void *)expected_seed_file);
+  free((void *)expected_input);
+  free((void *)expected_output);
+
   return EXIT_SUCCESS;
 }
diff --git a/tools/pkcs1-conv.c b/tools/pkcs1-conv.c
index 40420c4..042b203 100644
--- a/tools/pkcs1-conv.c
+++ b/tools/pkcs1-conv.c
@@ -438,6 +438,8 @@ convert_public_key(struct nettle_buffer *buffer, unsigned length, const uint8_t
 		      nettle_buffer_reset(buffer);
 		      res = rsa_keypair_to_sexp(buffer, NULL, &pub, NULL) > 0;
 		    }
+
+		  rsa_public_key_clear(&pub);
 		}
 	      if (!res)
 		werror("SubjectPublicKeyInfo: Invalid RSA key.\n");
@@ -656,5 +658,8 @@ main(int argc, char **argv)
 	  fclose(f);
 	}
     }
+
+  nettle_buffer_clear(&buffer);
+
   return EXIT_SUCCESS;
 }
